diff -r 779c5a44c6a1 src/economy.cpp
--- a/src/economy.cpp	Fri Dec 04 22:02:37 2009 +0000
+++ b/src/economy.cpp	Wed Dec 16 19:19:57 2009 +0100
@@ -46,6 +46,7 @@
 #include "waypoint_base.h"
 #include "economy_base.h"
 #include "core/pool_func.hpp"
+#include "infrastructure_func.h"
 
 #include "table/strings.h"
 #include "table/sprites.h"
@@ -387,6 +388,49 @@
 		}
 	}
 
+	/* make the sharing settings the most permissive of the two companies */
+	if (new_owner != INVALID_OWNER) {
+		Company *c_new = Company::Get(new_owner);
+		CompanySharingSettings *old_settings = &Company::Get(old_owner)->sharing_current;
+		CompanySharingSettings *new_settings = &c_new->sharing_current;
+
+		VehicleType type;
+		FOR_ALL_SHARING_VEHTYPES(type) {
+			if (old_settings->IsSharingAllowed(type)) new_settings->SetSharingAllowed(type, true);
+			new_settings->SetSharingFee(type, min(old_settings->GetSharingFee(type), new_settings->GetSharingFee(type)));
+		}
+		for (CompanyID cid = COMPANY_FIRST; cid < MAX_COMPANIES; cid++) {
+			if (Company::IsValidID(cid) && old_settings->IsCompanyAllowed(cid)) new_settings->SetCompanyAllowed(cid, true);
+		}
+
+		/* Make the future settings for the new company the same as the (new) current ones */
+		c_new->sharing_future = *new_settings;
+		c_new->sharing_delay = 0;
+	} else {
+		/* Disable sharing for the old company
+		 * This will cause all vehicles on the old company's infrastructure
+		 * to be removed when ProcessSharingChanges is called */
+		Company *c_old = Company::Get(old_owner);
+		VehicleType type;
+		FOR_ALL_SHARING_VEHTYPES(type) {
+			c_old->sharing_future.SetSharingAllowed(type, false);
+		}
+		c_old->sharing_delay = 0;
+		ProcessSharingChanges();
+	}
+
+	/* disallow the old company from all infrastructure */
+	Company *c;
+	FOR_ALL_COMPANIES(c) {
+		c->sharing_current.SetCompanyAllowed(old_owner, false);
+		c->sharing_future.SetCompanyAllowed(old_owner, false);
+		/* Future and current settings could now be equal
+		 * In that case, set sharing_delay to 0 */
+		if (c->sharing_current.Equals(&c->sharing_future)) {
+			c->sharing_delay = 0;
+		}
+	}
+
 	/*  Change ownership of tiles */
 	{
 		TileIndex tile = 0;
@@ -699,6 +743,18 @@
 	}
 }
 
+/**
+ * Update the sharing settings of a all companies, if needed.
+ */
+static void CompaniesUpdateSharing()
+{
+	Company *c;
+	FOR_ALL_COMPANIES(c) {
+		if (c->sharing_delay > 0) --c->sharing_delay;
+	}
+	ProcessSharingChanges();
+}
+
 static void HandleEconomyFluctuations()
 {
 	if (_settings_game.difficulty.economy != 0) {
@@ -1414,6 +1470,7 @@
 		RecomputePrices();
 	}
 	CompaniesPayInterest();
+	CompaniesUpdateSharing();
 	/* Reset the _current_company flag */
 	_current_company = OWNER_NONE;
 	HandleEconomyFluctuations();
diff -r 779c5a44c6a1 src/economy_type.h
--- a/src/economy_type.h	Fri Dec 04 22:02:37 2009 +0000
+++ b/src/economy_type.h	Wed Dec 16 19:19:57 2009 +0100
@@ -148,6 +148,8 @@
 	EXPENSES_SHIP_INC,
 	EXPENSES_LOAN_INT,
 	EXPENSES_OTHER,
+	EXPENSES_SHARED_RUN,
+	EXPENSES_SHARED_INC,
 	EXPENSES_END,
 	INVALID_EXPENSES      = 0xFF,
 };
diff -r 779c5a44c6a1 src/infrastructure.cpp
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/src/infrastructure.cpp	Wed Dec 16 19:19:57 2009 +0100
@@ -0,0 +1,441 @@
+/* $Id$ */
+
+/*
+ * This file is part of OpenTTD.
+ * OpenTTD is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 2.
+ * OpenTTD is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with OpenTTD. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/** @file infrastructure.cpp Implementation of infrastructure sharing */
+
+#include "infrastructure_func.h"
+#include "command_func.h"
+#include "window_func.h"
+#include "depot_base.h"
+#include "train.h"
+#include "aircraft.h"
+#include "vehicle_func.h"
+#include "news_func.h"
+#include "strings_func.h"
+#include "pathfinder/yapf/yapf_cache.h"
+#include "date_func.h"
+#include "gfx_func.h"
+#include "company_func.h"
+#include "station_base.h"
+#include "waypoint_base.h"
+
+#include "table/strings.h"
+
+bool CompanySharingSettings::Equals(const CompanySharingSettings *o) const
+{
+	VehicleType type;
+	FOR_ALL_SHARING_VEHTYPES(type) {
+		if (this->IsSharingAllowed(type) != o->IsSharingAllowed(type) || this->GetSharingFee(type) != o->GetSharingFee(type)) return false;
+	}
+	return this->allowed_companies == o->allowed_companies;
+}
+
+void CompanySharingSettings::CopyFromGameSettings()
+{
+	this->SetSharingAllowed(VEH_TRAIN,    _settings_game.sharing.rail_sharing);
+	this->SetSharingAllowed(VEH_ROAD,     _settings_game.sharing.road_sharing);
+	this->SetSharingAllowed(VEH_SHIP,     _settings_game.sharing.water_sharing);
+	this->SetSharingAllowed(VEH_AIRCRAFT, _settings_game.sharing.air_sharing);
+
+	this->SetSharingFee(VEH_TRAIN,    _settings_game.sharing.rail_fee);
+	this->SetSharingFee(VEH_ROAD,     _settings_game.sharing.road_fee);
+	this->SetSharingFee(VEH_SHIP,     _settings_game.sharing.water_fee);
+	this->SetSharingFee(VEH_AIRCRAFT, _settings_game.sharing.air_fee);
+
+	for (CompanyID c = COMPANY_FIRST; c < MAX_COMPANIES; c++) {
+		this->SetCompanyAllowed(c, Company::IsValidID(c));
+	}
+}
+
+/** Some constants regarding the time between two (identical) news messages */
+enum {
+	SHARING_NEWS_INTERVAL_INSOLVENCY     = 60, ///< 60 days between two warnings about company XX not paying because of debts
+	SHARING_NEWS_INTERVAL_SETTING_CHANGE = 10, ///< 10 days between two messages about company XX announcing to change its sharing settings
+};
+
+/**
+ * Add a sharing-related news message to the news stack.
+ * @param string The message string to show.
+ * @param c Company this message is about.
+ * @param param Optional additional parameter to use for drawing the string.
+ */
+static void AddSharingNewsItem(StringID string, Company *c, uint32 param = 0)
+{
+	CompanyNewsInformation *cni = MallocT<CompanyNewsInformation>(1);
+	cni->FillData(c);
+
+	SetDParam(0, STR_NEWS_SHARING_TITLE);
+	SetDParam(1, string);
+	SetDParamStr(2, cni->company_name);
+	SetDParam(3, param);
+
+	AddCompanyNewsItem(STR_MESSAGE_NEWS_FORMAT, NS_COMPANY_SHARING, cni);
+}
+
+
+/**
+ * Helper function for transferring sharing fees
+ * @param v The vehicle involved
+ * @param owner The owner of the infrastructure
+ * @param cost Amount to transfer as money fraction (shifted 8 bits to the left)
+ */
+static void PaySharingFee(Vehicle *v, Owner owner, Money cost)
+{
+	Company *c = Company::GetIfValid(v->owner);
+	assert(c != NULL);
+	if (_settings_game.sharing.payment_in_debt || (c->money - c->current_loan) >= (cost >> 8)) {
+		v->profit_this_year -= cost;
+		SubtractMoneyFromCompanyFract(v->owner, CommandCost(EXPENSES_SHARED_RUN, cost));
+		SubtractMoneyFromCompanyFract(owner, CommandCost(EXPENSES_SHARED_INC, -cost));
+	} else if (owner == _local_company && (c->sharing_insolvency_news_date + SHARING_NEWS_INTERVAL_INSOLVENCY) <= _date) {
+		AddSharingNewsItem(STR_NEWS_SHARING_UNABLE_TO_PAY, c);
+		c->sharing_insolvency_news_date = _date;
+	}
+}
+
+/**
+ * Pay the fee for spending a single tick inside a station.
+ * @param v The vehicle that is using the station.
+ * @param st The station that it uses.
+ */
+void PayStationSharingFee(Vehicle *v, const Station *st)
+{
+	if (v->owner == st->owner || st->owner == OWNER_NONE || v->type == VEH_TRAIN) return;
+	Money cost = GetSharingFee(st->owner, v->type);
+	PaySharingFee(v, st->owner, (cost << 8) / DAY_TICKS);
+}
+
+/**
+ * Pay the daily fee for trains on foreign tracks.
+ * @param v The vehicle to pay the fee for.
+ */
+void PayDailyTrackSharingFee(Train *v)
+{
+	Owner owner = GetTileOwner(v->tile);
+	if (owner == v->owner) return;
+	Money cost = GetSharingFee(owner, VEH_TRAIN);
+	cost = (cost << 8) * v->tcache.cached_total_length / 16; //cost is per 16 units = 1 tile
+	cost = cost * 12 / DAYS_IN_YEAR; //cost is per month, but we pay daily.
+	PaySharingFee(v, owner, cost);
+}
+
+/**
+ * Change the sharing settings of a company.
+ * @see ModifySharingFlag
+ * @param tile unused
+ * @param flags operation to perform
+ * @param p1 bitstuffed elements regarding the variable to change:
+ * - p1 = (bit 0 -  7) What to change (boolean option, fee or allowed company)
+ * - p1 = (bit 8 - 15) The vehicle type or company to change it for.
+ * @param p2 value to change the aforementioned variable to
+ * @param text unused
+ * @return the cost of this operation or an error
+ */
+CommandCost CmdChangeSharingSetting(TileIndex tile, DoCommandFlag flags, uint32 p1, uint32 p2, const char *text)
+{
+	if (_settings_game.sharing.sharing_mode != SHARING_INDIVIDUAL) return CMD_ERROR;
+	byte index = GB(p1, 8, 8); //vehicle type or company id
+
+	Company *c = Company::GetIfValid(_current_company);
+	if (c == NULL) return CMD_ERROR;
+
+	ModifySharingFlag msf = (ModifySharingFlag)GB(p1, 0, 8);
+	switch (msf) {
+		case MODIFY_SHARING_OPTION:
+			if (index >= NUM_SHARING_VEHTYPES) return CMD_ERROR;
+			if (!!p2 == c->sharing_future.IsSharingAllowed((VehicleType)index)) return CMD_ERROR;
+			break;
+		case MODIFY_SHARING_FEE:
+			if (index >= NUM_SHARING_VEHTYPES) return CMD_ERROR;
+			if (p2 > MAX_SHARING_FEE || p2 == c->sharing_future.GetSharingFee((VehicleType)index)) return CMD_ERROR;
+			break;
+		case MODIFY_SHARING_COMPANIES:
+			if (!Company::IsValidID(index) || index == _current_company) return CMD_ERROR;
+			if (!!p2 == c->sharing_future.IsCompanyAllowed((CompanyID)index)) return CMD_ERROR;
+			break;
+		default: return CMD_ERROR;
+	}
+
+	if (flags & DC_EXEC) {
+		switch (msf) {
+			case MODIFY_SHARING_OPTION:    c->sharing_future.SetSharingAllowed((VehicleType)index, p2 != 0); break;
+			case MODIFY_SHARING_FEE:       c->sharing_future.SetSharingFee((VehicleType)index, p2);          break;
+			case MODIFY_SHARING_COMPANIES: c->sharing_future.SetCompanyAllowed((CompanyID)index, p2 != 0);   break;
+			default: NOT_REACHED();
+		}
+
+		/* Set the sharing delay, and copy the future settings to the current settings if needed */
+		if (c->sharing_future.Equals(&c->sharing_current)) {
+			c->sharing_delay = 0;
+		} else if (_settings_game.sharing.new_individual_delay == 0) {
+			assert(c->sharing_delay == 0);
+			ProcessSharingChanges();
+		} else {
+			c->sharing_delay = _settings_game.sharing.new_individual_delay;
+			if (_current_company != _local_company && c->sharing_setting_change_news_date + SHARING_NEWS_INTERVAL_SETTING_CHANGE <= _date) {
+				c->sharing_setting_change_news_date = _date;
+				AddSharingNewsItem(STR_NEWS_SHARING_CHANGE_ANNOUNCED, c, c->sharing_delay);
+			}
+		}
+		InvalidateWindowData(WC_SHARING_OPTIONS, _current_company);
+	}
+	return CommandCost();
+}
+
+/**
+ * Helper function to determine if sharing is allowed according to the *new* sharing settings.
+ * @see IsInfraUsageAllowed(Owner, Owner, VehicleType)
+ * @param infra_owner The owner of the infrastructure.
+ * @param v           The vehicle that wants to use the infrastructure of infra_owner.
+ * @return            True if sharing will be enabled after processing the changes, false otherwise.
+ */
+bool IsNewInfraUsageAllowed(Owner infra_owner, const Vehicle *v)
+{
+	if (infra_owner == v->owner || infra_owner == OWNER_NONE) return true;
+	assert(Company::IsValidID(infra_owner));
+	Company *c = Company::Get(infra_owner);
+	return c->sharing_delay == 0 ? c->sharing_future.IsCompanySharingAllowed(v->type, v->owner) : c->sharing_future.IsCompanySharingAllowed(v->type, v->owner);
+}
+
+/**
+ * Sell a vehicle, no matter where it may be.
+ * @param v The vehicle to sell
+ * @param num_sold_local_vehicles Number of sold vehicles owned by the local company. To be increased by one if applicable.
+ */
+static void RemoveAndSellVehicle(Vehicle *v, uint &num_sold_local_vehicles)
+{
+	if (v->owner == _local_company) num_sold_local_vehicles++;
+
+	/* compute total value and give that to the owner */
+	Money value = 0;
+	for (Vehicle *u = v->First(); u != NULL; u = u->Next()) {
+		value += v->value;
+	}
+	SubtractMoneyFromCompanyFract(v->owner, CommandCost(EXPENSES_NEW_VEHICLES, -(value << 8)));
+
+	if (v->type == VEH_TRAIN && Train::From(v)->IsFrontEngine()) {
+		DeleteVisibleTrain(Train::From(v));
+	} else {
+		delete v;
+	}
+}
+
+/**
+ * Check the positions of all vehicles.
+ * If it is not in an allowed position,
+ * (e.g. a train is on foreign tracks when the owner disables sharing)
+ * then it is sold immediately.
+ * @param changed_vehtypes bitmask of vehicle types that were affected by a sharing setting change.
+ * @return The number of vehicles owned by the local company that have been sold.
+ */
+static uint CheckAllVehiclePositions(byte changed_vehtypes)
+{
+	uint num_sold_local_vehicles = 0;
+	Vehicle *v;
+	FOR_ALL_VEHICLES(v) {
+		if (!(v->IsPrimaryVehicle() || (v->type == VEH_TRAIN && Train::From(v)->IsFreeWagon()))) continue;
+		if (!HasBit(changed_vehtypes, v->type)) continue;
+		switch (v->type) {
+			case VEH_TRAIN:
+				for (Vehicle *u = v; u != NULL; u = u->Next()) {
+					/* If any wagon is on a disallowed tile, sell the entire train */
+					if (!IsNewInfraUsageAllowed(GetTileOwner(u->tile), u)) {
+						RemoveAndSellVehicle(v, num_sold_local_vehicles);
+						break;
+					}
+				}
+				break;
+			case VEH_ROAD:
+				for (Vehicle *u = v; u != NULL; u = u->Next()) {
+					/* Check all articulated parts */
+					if ((IsRoadDepotTile(u->tile) || IsStandardRoadStopTile(u->tile)) && !IsNewInfraUsageAllowed(GetTileOwner(u->tile), u)) {
+						RemoveAndSellVehicle(v, num_sold_local_vehicles);
+						break;
+					}
+				}
+				break;
+			case VEH_SHIP:
+				if (IsShipDepotTile(v->tile) && v->IsStoppedInDepot() && !IsNewInfraUsageAllowed(GetTileOwner(v->tile), v)) {
+					RemoveAndSellVehicle(v, num_sold_local_vehicles);
+				}
+				break;
+			case VEH_AIRCRAFT: {
+				Aircraft *a = Aircraft::From(v);
+				if (a->state == FLYING) break;
+				if (Station::IsValidID(a->targetairport) && !IsNewInfraUsageAllowed(Station::Get(a->targetairport)->owner, v)) {
+						RemoveAndSellVehicle(v, num_sold_local_vehicles);
+				}
+				break;
+			}
+			default: break;
+		}
+	}
+	return num_sold_local_vehicles;
+}
+
+/**
+ * Check whether an order has an allowed destination.
+ * I.e. it refers to a station/depot/waypoint the vehicle is allowed to visit.
+ * @param o The order to check
+ * @param v The vehicle this order belongs to.
+ * @return true if the order has an allowed destination.
+ */
+static bool OrderDestinationIsAllowed(const Order *o, const Vehicle *v)
+{
+	DestinationID dest = o->GetDestination();
+	switch (o->GetType()) {
+		case OT_GOTO_STATION:  return IsNewInfraUsageAllowed(Station::Get(dest)->owner, v);
+		case OT_GOTO_DEPOT:    return IsNewInfraUsageAllowed(v->type == VEH_AIRCRAFT ? Station::Get(dest)->owner : GetTileOwner(Depot::Get(dest)->xy), v);
+		case OT_GOTO_WAYPOINT: return IsNewInfraUsageAllowed(Waypoint::Get(dest)->owner, v);
+		default: return true;
+	}
+}
+
+/**
+ * Review the orders of all vehicles
+ * This makes sure they don't have any orders to destinations
+ * where they are not allowed to go.
+ * @param changed_vehtypes bitmask of vehicle types that were affected by a sharing setting change.
+ */
+static void ReviewAllVehicleOrders(byte changed_vehtypes)
+{
+	Vehicle *v;
+	FOR_ALL_VEHICLES(v) {
+		if (!(v->IsPrimaryVehicle() && HasBit(changed_vehtypes, v->type))) continue;
+
+		if (!OrderDestinationIsAllowed(&v->current_order, v)) {
+			v->current_order.MakeDummy();
+			SetWindowDirty(WC_VEHICLE_VIEW, v->index);
+		} else if (v->current_order.IsType(OT_LOADING)) {
+			if (!IsNewInfraUsageAllowed(Station::Get(v->last_station_visited)->owner, v)) {
+				v->LeaveStation();
+			}
+		}
+
+		if (v->FirstShared() != v) continue;
+
+		Order *o;
+		int id = -1;
+		FOR_VEHICLE_ORDERS(v, o) {
+			id++;
+			if (OrderDestinationIsAllowed(o, v)) continue;
+
+			o->MakeDummy();
+			for (const Vehicle *w = v->FirstShared(); w != NULL; w = w->NextShared()) {
+				/* In GUI, simulate by removing the order and adding it back */
+				InvalidateVehicleOrder(w, id | (INVALID_VEH_ORDER_ID << 8));
+				InvalidateVehicleOrder(w, (id << 8) | INVALID_VEH_ORDER_ID);
+			}
+		}
+	}
+}
+
+/** Bitmask of all relevant vehicle types. */
+static const byte ALL_SHARING_VEHTYPES = (1 << VEH_TRAIN) | (1 << VEH_ROAD) | (1 << VEH_SHIP) | (1 << VEH_AIRCRAFT);
+
+/**
+ * Handle a change of sharing settings.
+ * This involves checking all orders,
+ * making sure all vehicles are not on disallowed territory,
+ * checking all PBS paths
+ * and updating signals.
+ * @param update_signals Force updating all signals on the map.
+ */
+void ProcessSharingChanges()
+{
+	byte changed_vehtypes = 0;
+	CompanyMask changed_companies = 0;
+
+	/* Collect a bitmask of vehicle types that will be negatively affected by the new settings.
+	 * And also a bitmask of companies whose settings were changed.
+	 * N.B. Changes to the fee have no effect on changed_vehtypes. So there could still be changes when changed_vehtypes == 0.
+	 * However if there are any changes changed_companies will not be 0 */
+	Company *c;
+	FOR_ALL_COMPANIES(c) {
+		if (c->sharing_delay != 0 || c->sharing_current.Equals(&c->sharing_future)) continue;
+		SetBit(changed_companies, c->index);
+		VehicleType type;
+		FOR_ALL_SHARING_VEHTYPES(type) {
+			if (c->sharing_current.IsSharingAllowed(type) && !c->sharing_future.IsSharingAllowed(type)) {
+				SetBit(changed_vehtypes, type);
+			}
+		}
+		Company *c2;
+		FOR_ALL_COMPANIES(c2) {
+			if (c->sharing_current.IsCompanyAllowed(c2->index) && !c->sharing_future.IsCompanyAllowed(c2->index)) {
+				changed_vehtypes = ALL_SHARING_VEHTYPES;
+			}
+		}
+	}
+	InvalidateWindowClassesData(WC_SHARING_OPTIONS);
+	if (changed_companies == 0) return;
+
+	uint num_sold_local_vehicles = 0;
+	if (changed_vehtypes != 0)  {
+		/* Invalidate the entire cache */
+		YapfNotifyTrackLayoutChange(INVALID_TILE, INVALID_TRACK);
+
+		num_sold_local_vehicles = CheckAllVehiclePositions(changed_vehtypes);
+		ReviewAllVehicleOrders(changed_vehtypes);
+	}
+
+	if (ClrBit(changed_companies, _local_company) != 0) {
+		Company *news_company = Company::GetIfValid(FindFirstBit(changed_companies));
+		assert(news_company != NULL);
+		AddSharingNewsItem(STR_NEWS_SHARING_CHANGE_HAPPENED, news_company);
+		if (num_sold_local_vehicles != 0) {
+			AddSharingNewsItem(STR_NEWS_SHARING_SOLD_VEHICLES, news_company, num_sold_local_vehicles);
+		}
+	}
+
+	/* Apply the changes to the sharing settings */
+	FOR_ALL_COMPANIES(c) {
+		if (c->sharing_delay == 0) c->sharing_current = c->sharing_future;
+	}
+
+}
+
+/** Small struct to store a tile/track combination */
+struct SignalPosition {
+	TileIndex tile;  ///< Tile of the signal.
+	Track     track; ///< Track piece of the signal.
+	/** Create a new SignalPosition based on given tile and track piece */
+	SignalPosition(TileIndex _tile, Track _track) : tile(_tile), track(_track) {};
+};
+
+/**
+ * Update all signals on the map.
+ * Since whe do not know which ones are affected by the sharing change, we invalidate them all.
+ * Updating signals can only be done on a per-company basis.
+ * Therefore, we cache all signals into lists, one per company
+ * Then we update all signals in each list.
+ */
+void UpdateAllBlockSignals()
+{
+	static SmallVector<SignalPosition, 256> signal_lists[MAX_COMPANIES];
+
+	for (TileIndex tile = 0; tile < MapSize(); tile++) {
+		if (IsTileType(tile, MP_RAILWAY) && HasSignals(tile)) {
+			TrackBits bits = GetTrackBits(tile);
+			do {
+				Track track = RemoveFirstTrack(&bits);
+				if (HasSignalOnTrack(tile, track)) {
+					*signal_lists[GetTileOwner(tile)].Append() = SignalPosition(tile, track);
+				}
+			} while (bits != TRACK_BIT_NONE);
+		}
+	}
+	for (CompanyID c = COMPANY_FIRST; c < MAX_COMPANIES; c++) {
+		for (uint i = 0; i < signal_lists[c].Length(); i++) {
+			AddTrackToSignalBuffer(signal_lists[c][i].tile, signal_lists[c][i].track, c);
+		}
+		UpdateSignalsInBuffer();
+		signal_lists[c].Reset();
+	}
+}
diff -r 779c5a44c6a1 src/infrastructure.h
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/src/infrastructure.h	Wed Dec 16 19:19:57 2009 +0100
@@ -0,0 +1,147 @@
+/* $Id$ */
+
+/*
+ * This file is part of OpenTTD.
+ * OpenTTD is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 2.
+ * OpenTTD is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with OpenTTD. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/** @file infrastructure.h Define struct and enums for (shared) infrastructure */
+
+#ifndef INFRASTRUCTURE_H
+#define INFRASTRUCTURE_H
+
+#include "stdafx.h"
+#include "core/bitmath_func.hpp"
+#include "vehicle_type.h"
+#include "company_type.h"
+
+/** Sharing modes; possible values for the sharing_mode setting. */
+enum SharingMode {
+	SHARING_NONE,       ///< No infrastructure sharing at all
+	SHARING_GLOBAL,     ///< Sharing enabled with global (advanced) settings
+	SHARING_INDIVIDUAL, ///< Sharing enabled with individually configurable settings
+};
+
+/** which part of the sharing settings do we want to modify? */
+enum ModifySharingFlag {
+	MODIFY_SHARING_OPTION,    ///< Modify access to station / depot / tracks
+	MODIFY_SHARING_FEE,       ///< Modify the sharing fee
+	MODIFY_SHARING_COMPANIES, ///< Modify which companies are allowed
+};
+
+/** maximum fee (in pounds) for any of the sharing fees */
+static const uint MAX_SHARING_FEE = 50000;
+
+/** number of relevant vehicle types */
+static const byte NUM_SHARING_VEHTYPES = 4;
+
+/** Struct to store all the sharing settings of a company (either current or future ones) */
+struct CompanySharingSettings {
+private:
+	friend const struct SaveLoad *GetCompanySharingSettingsDescription();
+
+	byte allowed_types;               ///< Bitmask of vehicle types for which sharing is enabled.
+	CompanyMask allowed_companies;    ///< Bitmask of companies for which sharing is enabled.
+	uint16 fee[NUM_SHARING_VEHTYPES]; ///< Fees for rail/road/water/air.
+
+public:
+	/** Constructor */
+	CompanySharingSettings() {}
+
+	/**
+	 * Compare two sets of sharing settings with eachother.
+	 * @param o The sharing settings entry to compare with.
+	 * @return True if all settings are equal, false otherwise.
+	 */
+	bool Equals(const CompanySharingSettings *o) const;
+
+	/**
+	 * Fill this struct with the values from _settings_game.
+	 * This also enables all companies in the allowed_companies mask.
+	 */
+	void CopyFromGameSettings();
+
+	/**
+	 * Is sharing allowed for a vehicle type?
+	 * @param type The vehicle type.
+	 * @return True if infrastructure sharing is enabled for that vehicle type.
+	 */
+	FORCEINLINE bool IsSharingAllowed(VehicleType type) const
+	{
+		assert(type < NUM_SHARING_VEHTYPES);
+		return HasBit(this->allowed_types, type);
+	}
+
+	/**
+	 * Check whether a company is allowed to use the infrastructure.
+	 * i.e. it's corresponding bit in allowed_companies is set.
+	 * @param c The company to check.
+	 * @return true if the given company is allowed to use the infrastructure
+	 */
+	FORCEINLINE bool IsCompanyAllowed(CompanyID c) const
+	{
+		assert(c < MAX_COMPANIES);
+		return HasBit(this->allowed_companies, c);
+	}
+
+	/**
+	 * Is sharing allowed for a vehicle of a given type and owner?
+	 * @param type Type of the vehicle.
+	 * @param c Owner of the vehicle.
+	 * @return True if infrastructure sharing is allowed, false otherwise.
+	 */
+	FORCEINLINE bool IsCompanySharingAllowed(VehicleType type, CompanyID c) const
+	{
+		return this->IsSharingAllowed(type) && this->IsCompanyAllowed(c);
+	}
+
+	/**
+	 * Get the sharing fee for a specified vehicle type.
+	 * @param type The vehicle type.
+	 * @return The sharing fee for the given vehicle type.
+	 */
+	FORCEINLINE uint16 GetSharingFee(VehicleType type) const
+	{
+		assert(type < NUM_SHARING_VEHTYPES);
+		return this->fee[type];
+	}
+
+	/**
+	 * Allow or disallow sharing for a vehicle type.
+	 * @param type The vehicle type.
+	 * @param value Allow sharing if true, disallow if false.
+	 */
+	FORCEINLINE void SetSharingAllowed(VehicleType type, bool value)
+	{
+		assert(type < NUM_SHARING_VEHTYPES);
+		SB(this->allowed_types, type, 1, !!value);
+	}
+
+	/**
+	 * Allow or disallow a company to use the infrastructure.
+	 * @param c The index of the company to allow or disallow.
+	 * @param value Allow sharing if true, disallow if false.
+	 */
+	FORCEINLINE void SetCompanyAllowed(CompanyID c, bool value)
+	{
+		assert(c < MAX_COMPANIES);
+		SB(this->allowed_companies, c, 1, !!value);
+	}
+
+	/**
+	 * Set the sharing fee for a specified vehicle type.
+	 * @param type The vehicle type.
+	 * @param value The new sharing fee.
+	 */
+	FORCEINLINE void SetSharingFee(VehicleType type, uint16 value)
+	{
+		assert(type < NUM_SHARING_VEHTYPES);
+		this->fee[type] = value;
+	}
+};
+
+#define FOR_ALL_SHARING_VEHTYPES(var) for (var = VEH_TRAIN; var < NUM_SHARING_VEHTYPES; var++)
+
+#endif /* INFRASTRUCTURE_H */
diff -r 779c5a44c6a1 src/infrastructure_func.h
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/src/infrastructure_func.h	Wed Dec 16 19:19:57 2009 +0100
@@ -0,0 +1,127 @@
+/* $Id$ */
+
+/*
+ * This file is part of OpenTTD.
+ * OpenTTD is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 2.
+ * OpenTTD is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with OpenTTD. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/** @file infrastructure_func.h Functions for infrastructure sharing */
+
+#ifndef INFRASTRUCTURE_FUNC_H
+#define INFRASTRUCTURE_FUNC_H
+
+#include "infrastructure.h"
+#include "functions.h"
+#include "company_base.h"
+#include "vehicle_base.h"
+#include "company_func.h"
+
+void PayStationSharingFee(Vehicle *v, const Station *st);
+void PayDailyTrackSharingFee(Train *v);
+void ProcessSharingChanges();
+void UpdateAllBlockSignals();
+
+/**
+ * Get whether a vehicle of a given owner and type can use the infrastrucutre of a company.
+ * This function has three other versions with slightly different parameters.
+ * All functions basically work the same. Possible parameter variations:
+ * - A tile instead of the infrastructure owner. The infrastructure owner is then equal to GetTileOwner(tile).
+ * - A vehicle instead of a vehicle owner and vehicle type. Use the owner and type of the vehicle.
+ * @param infra_owner The owner of the infrastructure.
+ * @param veh_owner   Owner of the vehicle in question.
+ * @param type        Type of vehicle we are talking about.
+ * @return            True if sharing is enabled, false otherwise.
+ */
+static inline bool IsInfraUsageAllowed(Owner infra_owner, Owner veh_owner, VehicleType type)
+{
+	assert(Company::IsValidID(infra_owner) || infra_owner == OWNER_NONE);
+	return infra_owner == veh_owner || infra_owner == OWNER_NONE || Company::Get(infra_owner)->sharing_current.IsCompanySharingAllowed(type, veh_owner);
+}
+
+/** @see IsInfraUsageAllowed(Owner, Owner, VehicleType) */
+static FORCEINLINE bool IsInfraUsageAllowed(Owner owner, const Vehicle *v)
+{
+	return IsInfraUsageAllowed(owner, v->owner, v->type);
+}
+
+/** @see IsInfraUsageAllowed(Owner, Owner, VehicleType) */
+static FORCEINLINE bool IsInfraUsageAllowed(TileIndex tile, Owner veh_owner, VehicleType type)
+{
+	return IsInfraUsageAllowed(GetTileOwner(tile), veh_owner, type);
+}
+
+/** @see IsInfraUsageAllowed(Owner, Owner, VehicleType) */
+static FORCEINLINE bool IsInfraUsageAllowed(TileIndex tile, const Vehicle *v)
+{
+	return IsInfraUsageAllowed(GetTileOwner(tile), v->owner, v->type);
+}
+
+/**
+ * Is a vehicle owned by _current_company allowed to use the infrastructure?
+ * @see IsInfraUsageAllowed(Owner, Owner, VehicleType)
+ * @note This function is to be used in DoCommands.
+ * @param infra_owner Owner of the infrastructure.
+ * @param type Type of vehicle.
+ * @return True if usage of the infrastructure is allowed.
+ */
+static inline bool CheckInfraUsageAllowed(Owner infra_owner, VehicleType type)
+{
+	return CheckOwnership(infra_owner) || IsInfraUsageAllowed(infra_owner, _current_company, type);
+}
+
+/** @see CheckInfraUsageAllowed(Owner, VehicleType) */
+static inline bool CheckInfraUsageAllowed(TileIndex tile, VehicleType type)
+{
+	return CheckTileOwnership(tile) || IsInfraUsageAllowed(GetTileOwner(tile), _current_company, type);
+}
+
+/**
+ * Get the sharing fee the infrastructure owner asks for using the infrastructure for a vehicle type.
+ * @param owner The owner of the infrastructure.
+ * @param type The vehicle type.
+ * @return The sharing fee that applies here.
+ */
+static inline uint16 GetSharingFee(Owner owner, VehicleType type)
+{
+	assert(Company::IsValidID(owner));
+	return Company::Get(owner)->sharing_current.GetSharingFee(type);
+}
+
+
+/**
+ * Check whether a given company can control this vehicle.
+ * The vehicle owner can always control a vehicle.
+ * Trains on foreign tracks can also be controlled by the track owner.
+ * Controlling a train means permission to start, stop or reverse it or to make it ignore signals.
+ * This function has one alias, which does not take a company as parameter. Instead it uses _current_company.
+ * This is very useful in DoCommands, since it uses Check[Tile]Ownership. (It gives nice error messages when failing)
+ * @param v The vehicle which may or may not be controlled.
+ * @param o The company which may or may not control this vehicle
+ * @return true if the given company is allowed to control this vehicle.
+ */
+static inline bool IsVehicleControlAllowed(const Vehicle *v, Owner o)
+{
+	return v->owner == o || (v->type == VEH_TRAIN && IsTileOwner(v->tile, o));
+}
+
+/** @see IsVehicleControlAllowed(const Vehicle *, Owner) */
+static inline bool IsVehicleControlAllowed(const Vehicle *v)
+{
+	return CheckOwnership(v->owner) || (v->type == VEH_TRAIN && CheckTileOwnership(v->tile));
+}
+
+/**
+ * Are the tracks of two owners part of the same signal block?
+ * This is the case if the owners are equal, or if infrastructure sharing is enabled
+ * @param o1 First company.
+ * @param o2 Second company.
+ * @return true if the tracks of the given owners are part of the same signal block
+ */
+static inline bool AreSignalBlocksJoined(Owner o1, Owner o2)
+{
+	return (o1 == o2) || (_settings_game.sharing.sharing_mode != SHARING_NONE);
+}
+
+#endif /* INFRASTRUCTURE_FUNC_H */
diff -r 779c5a44c6a1 src/news_func.h
--- a/src/news_func.h	Fri Dec 04 22:02:37 2009 +0000
+++ b/src/news_func.h	Wed Dec 16 19:19:57 2009 +0100
@@ -16,6 +16,7 @@
 #include "vehicle_type.h"
 #include "station_type.h"
 #include "industry_type.h"
+#include "company_type.h"
 
 void AddNewsItem(StringID string, NewsSubtype subtype, NewsReferenceType reftype1 = NR_NONE, uint32 ref1 = UINT32_MAX, NewsReferenceType reftype2 = NR_NONE, uint32 ref2 = UINT32_MAX, void *free_data = NULL);
 
